﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;

namespace CollectionEx
{
    class Program
    {
        static void Main(string[] args)
        {
            new Program();

            Console.WriteLine("Press Any Key...");
            Console.ReadLine();
        }

        const String DEFAULT_TABLE  = "TABLE";
        String[] COLUMN = { "Data1", "Data2" };
        Type[] COLUMNTYPE = { typeof(Int32), typeof(String) };

        private DataSet m_DataSet;
        Dictionary<int, String> m_Dictionary;
        List<int> m_List;

        public Program()
        {
            TableInit();
            DataInsert();
            /*-------------------------Linq Test(DataSet)--------------------------------*/
            IEnumerable<DataRow> iBuffer = from Key in m_DataSet.Tables[0].AsEnumerable()
                                           where Key.Field<int>("Data1") > 5 
                                           select Key;

            DataTable buffer =  iBuffer.CopyToDataTable<DataRow>();

            foreach(DataRow dr in buffer.Rows)
            {
                Console.WriteLine(dr[1]);
            }
            /*-------------------------Linq Test --------------------------------*/

            Console.WriteLine("...................................................");
            DictionaryInit();
            DictionaryInsert();

            /*-------------------------Linq Test(Dictionary)--------------------------------*/
            IEnumerable<KeyValuePair<int, string>> selectedValue = from Key in m_Dictionary
                                                                    where Key.Key > 5
                                                                    select Key;

            foreach (KeyValuePair<int, string> data in selectedValue)
            {
                Console.WriteLine("{0} \t {1}",data.Key,data.Value);
            }

            
            /*------------------------------------------------------------------------------*/
            Console.WriteLine("...................................................");
            ListInit();
            ListInsert();

            /*-------------------------Linq Test(List) --------------------------------*/
            IEnumerable<int> selectedValues2 = from Key in m_List
                                        where Key > 5
                                        select Key;

            List<int> buffer3 = selectedValues2.ToList<int>();
            foreach (int data in buffer3)
            {
                Console.WriteLine(data.ToString());
            }

            /*------------------------------------Join------------------------------------------*/
            Console.WriteLine("...................................................");
            IEnumerable<KeyValuePair<int, string>> iBuffer3 = 
                        from dbdb2 in m_DataSet.Tables[0].AsEnumerable()
                         join dbdb in m_Dictionary
                             on dbdb2.Field<int>("Data1") equals dbdb.Key into aaa
                         from bbb in aaa
                         where bbb.Key > 5
                        orderby bbb.Key descending
                         select bbb;

            foreach (KeyValuePair<int, string> aa in iBuffer3)
            {
                Console.WriteLine(aa.Value.ToString());
            }
        }

        protected void ListInsert()
        {
            m_List.Add(1);
            m_List.Add(2);
            m_List.Add(3);
            m_List.Add(4);
            m_List.Add(5);
            m_List.Add(6);
            m_List.Add(7);
            m_List.Add(8);
            m_List.Add(9);
            m_List.Add(10);
        }
        protected void ListInit()
        {
            m_List = new List<int>();
        }

        protected void DictionaryInit()
        {
            m_Dictionary = new Dictionary<int, string>();
        }
        protected void DictionaryInsert()
        {
            m_Dictionary.Add(0, "ゼロDic");
            m_Dictionary.Add(1, "イチDic");
            m_Dictionary.Add(2, "二Dic");
            m_Dictionary.Add(3, "サンDic");
            m_Dictionary.Add(4, "ヨンDic");
            m_Dictionary.Add(5, "ゴDic");
            m_Dictionary.Add(6, "ロクDic");
            m_Dictionary.Add(7, "シチDic");
            m_Dictionary.Add(8, "ハチDic");
            m_Dictionary.Add(9, "キュウDic");
            m_Dictionary.Add(10, "ジュウDic");
        }
        protected void DataInsert()
        {
            WriteRow(0, "ゼロ");
            WriteRow(1, "イチ");
            WriteRow(2, "二");
            WriteRow(3, "サン");
            WriteRow(4, "ヨン");
            WriteRow(5, "ゴ");
            WriteRow(6, "ロク");
            WriteRow(7, "シチ");
            WriteRow(8, "ハチ");
            //WriteRow(9, "キュウ");
            WriteRow(10, "ジュウ");
        }

        protected void TableInit()
        {
            m_DataSet = new DataSet();
            m_DataSet.Tables.Add(new DataTable(DEFAULT_TABLE));
            foreach (String Column in COLUMN)
            {
                m_DataSet.Tables[DEFAULT_TABLE].Columns.Add(new DataColumn(Column));
            }
            for (int i = 0; i < COLUMNTYPE.Length ; i++)
            {
                m_DataSet.Tables[DEFAULT_TABLE].Columns[i].DataType = COLUMNTYPE[i];
            }
        }
        protected void WriteRow(int Column1, String Column2)
        {
            DataRow buffer = m_DataSet.Tables[DEFAULT_TABLE].NewRow();
            buffer[0] = Column1;
            buffer[1] = Column2;
            m_DataSet.Tables[DEFAULT_TABLE].Rows.Add(buffer);
        }
    }
}
